N=100;      % signal length
lambda=100;   % regularization constant (make experiments!)
K=10;        % level of the noise (make experiments!)

N1=N-2;
x0=[zeros(N/2-10,1); 100*ones(20,1); zeros(N/2-10,1)];  % impulse signal
yv=x0+K*randn(N,1);                                     % noisy signal
D=zeros(N1,N);
for i=1:N1, D(i,i)=1; D(i,i+1)=-2; D(i,i+2)=1; end;     % generating regularization matrix
D(N1-1,N1+1)=1; D(N1,N1+1)=-2; D(N1,N1+2)=1; 
Finv=inv(eye(N)+lambda*D'*D);
yvfilt=Finv*yv;                                         % computing LS estimate
figure(2), plot([1:N],yv,'b',[1:N],yvfilt,'r'); grid;







